package com.vendor.burn.commands;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.burn.commands.SerialCommand;
import com.vendor.burn.model.FlashType;

public class EraseCommand extends SerialCommand {
  private static final String KEY_ERASE = "erase";
  
  private static final String KEY_EMMC_ERASE = "mmc erase";
  
  public EraseCommand(String command) {
    setCommand(command);
  }
  
  public static com.vendor.burn.commands.EraseCommand erase(FlashType flashType, String address, String length) {
    StringBuilder sb = new StringBuilder();
    if (flashType == FlashType.spi) {
      sb.append("sf");
    } else {
      sb.append(flashType.name());
    } 
    sb.append(" ").append("erase").append(" ");
    if (!address.startsWith("0x"))
      sb.append("0x"); 
    sb.append(address).append(" ");
    if (!length.startsWith("0x"))
      sb.append("0x"); 
    sb.append(length);
    com.vendor.burn.commands.EraseCommand eraseCommand = new com.vendor.burn.commands.EraseCommand(sb.toString());
    eraseCommand.setTimeout(calTimeout(length, flashType));
    return eraseCommand;
  }
  
  public static com.vendor.burn.commands.EraseCommand eraseEmmc(String startAddress, String length, String timeout) {
    StringBuilder sb = new StringBuilder();
    sb.append("mmc erase");
    sb.append(" ").append(0);
    sb.append(" ").append(startAddress).append(" ");
    sb.append(length);
    com.vendor.burn.commands.EraseCommand eraseCommand = new com.vendor.burn.commands.EraseCommand(sb.toString());
    eraseCommand.setTimeout(calTimeout(timeout, FlashType.emmc));
    return eraseCommand;
  }
  
  public static int calTimeout(String length, FlashType flashType) {
    int timeout = 30000;
    int unit = 0;
    if (flashType == FlashType.spi) {
      unit = 30000;
    } else if (flashType == FlashType.nand) {
      unit = 15000;
    } else if (FlashType.fuzzyCompareFlash(flashType, FlashType.emmc)) {
      unit = 15000;
    } else {
      unit = 3000;
    } 
    if (length == null || length.length() == 0)
      return timeout; 
    long parseLong = getLength(length).longValue();
    timeout = (int)(unit * (parseLong / 1048576L + 1L));
    return timeout;
  }
}
